Index: typo3/sysext/rtehtmlarea/ext_conf_template.txt
===================================================================
--- typo3/sysext/rtehtmlarea/ext_conf_template.txt	(revision 3236)
+++ typo3/sysext/rtehtmlarea/ext_conf_template.txt	(working copy)
@@ -22,6 +22,9 @@
   # cat=basic/enable/110; type=boolean; label=Enable images in the RTE: If set, the use of images will be enabled in the default configuration of the RTE.
 enableImages = 0
 
+  # cat=basic/enable/115; type=boolean; label=Enable additional inline elements: If set, the potential use of additional inline elements will be enabled in the default configuration of the RTE.
+enableInlineElements = 0
+
   # cat=basic/enable/140; type=boolean; label=Enable links accessibility icons: If set, accessibility icons will be added in front of links.
 enableAccessibilityIcons = 0
 
Index: typo3/sysext/rtehtmlarea/ext_localconf.php
===================================================================
--- typo3/sysext/rtehtmlarea/ext_localconf.php	(revision 3236)
+++ typo3/sysext/rtehtmlarea/ext_localconf.php	(working copy)
@@ -70,8 +70,6 @@
 $TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['UserElements']['objectReference'] = 'EXT:'.$_EXTKEY.'/extensions/UserElements/class.tx_rtehtmlarea_userelements.php:&tx_rtehtmlarea_userelements';
 $TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['UserElements']['addIconsToSkin'] = 0;
 $TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['UserElements']['disableInFE'] = 1;
-$TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['InlineElements'] = array();
-$TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['InlineElements']['objectReference'] = 'EXT:'.$_EXTKEY.'/extensions/InlineElements/class.tx_rtehtmlarea_inlineelements.php:&tx_rtehtmlarea_inlineelements';
 $TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['TextStyle'] = array();
 $TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['TextStyle']['objectReference'] = 'EXT:'.$_EXTKEY.'/extensions/TextStyle/class.tx_rtehtmlarea_textstyle.php:&tx_rtehtmlarea_textstyle';
 $TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['DefaultImage'] = array();
@@ -176,6 +174,13 @@
 	t3lib_extMgm::addPageTSConfig('<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/res/image/pageTSConfig.txt">');
 }
 
+	// Configure extended Inline Elements
+if ($_EXTCONF['enableInlineElements']) {
+	$TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['InlineElements'] = array();
+	$TYPO3_CONF_VARS['EXTCONF']['rtehtmlarea']['plugins']['InlineElements']['objectReference'] = 'EXT:'.$_EXTKEY.'/extensions/InlineElements/class.tx_rtehtmlarea_inlineelements.php:&tx_rtehtmlarea_inlineelements';
+	t3lib_extMgm::addPageTSConfig('<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/extensions/InlineElements/res/proc/pageTSConfig.txt">');
+}
+
 	// Add default Page TSonfig RTE configuration for enabling links accessibility icons
 if ($TYPO3_CONF_VARS['EXTCONF'][$_EXTKEY]['enableAccessibilityIcons']) {
 	t3lib_extMgm::addPageTSConfig('<INCLUDE_TYPOSCRIPT: source="FILE:EXT:' . $_EXTKEY . '/res/accessibilityicons/pageTSConfig.txt">');
Index: typo3/sysext/rtehtmlarea/extensions/InlineElements/res/pageTSConfig.txt
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/InlineElements/res/pageTSConfig.txt	(revision 0)
+++ typo3/sysext/rtehtmlarea/extensions/InlineElements/res/pageTSConfig.txt	(revision 0)
@@ -0,0 +1,15 @@
+# ***************************************************************************************
+# Additonal proc options in Page TSconfig for Inline Elements extension
+#
+# @author	Stanislas Rolland <stanislas.rolland(arobas)fructifor.ca>
+#
+# TYPO3 SVN ID: $Id: pageTSConfig.txt $
+# ***************************************************************************************
+
+	## Default RTE processing rules
+RTE.default.proc {
+	
+		## DO NOT REMAP BOLD AND ITALIC TO STRONG AND EMPHASIS AND VICE VERSA
+	transformBoldAndItalicTags = 0
+	
+}
Index: typo3/sysext/rtehtmlarea/res/proc/pageTSConfig.txt
===================================================================
--- typo3/sysext/rtehtmlarea/res/proc/pageTSConfig.txt	(revision 3236)
+++ typo3/sysext/rtehtmlarea/res/proc/pageTSConfig.txt	(working copy)
@@ -55,8 +55,8 @@
 		## This is a list of additional attributes to keep
 	keepPDIVattribs = id, title, dir, lang, xml:lang
 	
-		## DO NOT REMAP BOLD AND ITALIC TO STRONG AND EMPHASIS AND VICE VERSA
-	transformBoldAndItalicTags = 0
+		## REMAP BOLD AND ITALIC TO STRONG AND EMPHASIS AND VICE VERSA
+	transformBoldAndItalicTags = 1
 	
 		## ALLOW TO WRITE ABOUT HTML
 	dontUndoHSC_db = 1