Index: index.php
===================================================================
--- index.php	(revision 3416)
+++ index.php	(working copy)
@@ -224,57 +224,7 @@
 
 
 
-
-	/*****************************
-	 *
-	 * Various functions
-	 *
-	 ******************************/
-
 	/**
-	 * Creates the login form
-	 * This is drawn when NO login exists.
-	 *
-	 * @return	string		HTML output
-	 */
-	function makeLoginForm()	{
-
-			// There must be no white-spaces outside of the tags (needed for buggy IE)
-		$content.=				'<!--
-								Login form:
-							--><table cellspacing="0" cellpadding="0" border="0" id="logintable">
-									<tr>
-										<td colspan="2"><h2>'.htmlspecialchars($this->L_vars[6]).'</h2></td>
-									</tr>'.($this->commandLI ? '
-									<tr class="c-wrong">
-										<td colspan="2"><p class="c-wrong">'.htmlspecialchars($this->L_vars[9]).'</p></td>
-									</tr>' : '').'
-									<tr class="c-username">
-										<td><p class="c-username">'.htmlspecialchars($this->L_vars[0]).':</p></td>
-										<td><input type="text" name="username" value="'.htmlspecialchars($this->u).'" class="c-username" /></td>
-									</tr>
-									<tr class="c-password">
-										<td><p class="c-password">'.htmlspecialchars($this->L_vars[1]).':</p></td>
-										<td><input type="password" name="p_field" value="'.htmlspecialchars($this->p).'" class="c-password" /></td>
-									</tr>'.($this->interfaceSelector && !$this->loginRefresh ? '
-									<tr class="c-interfaceselector">
-										<td><p class="c-interfaceselector">'.htmlspecialchars($this->L_vars[2]).':</p></td>
-										<td>'.$this->interfaceSelector.'</td>
-									</tr>' : '' ).'
-									<tr class="c-submit">
-										<td></td>
-										<td><input type="submit" name="commandLI" value="'.htmlspecialchars($this->L_vars[3]).'" class="c-submit" /></td>
-									</tr>
-									<tr class="c-info">
-										<td colspan="2"><p class="c-info">'.htmlspecialchars($this->L_vars[7]).'</p></td>
-									</tr>
-								</table>';
-
-			// Return content:
-		return $content;
-	}
-
-	/**
 	 * Creates the logout form
 	 * This is drawn if a user login already exists.
 	 *
@@ -315,7 +265,58 @@
 		return $content;
 	}
 
+	/*****************************
+	 *
+	 * Various functions
+	 *
+	 ******************************/
+
 	/**
+	 * Creates the login form
+	 * This is drawn when NO login exists.
+	 *
+	 * @return	string		HTML output
+	 */
+	function makeLoginForm()	{
+
+			// There must be no white-spaces outside of the tags (needed for buggy IE)
+		$content.=				'<!--
+								Login form:
+							--><div id="logintable">
+									<fieldset>
+										<legend>Login</legend>
+										<h2>'.htmlspecialchars($this->L_vars[6]).'</h2>
+										'.($this->commandLI ? '<p class="c-wrong">'.htmlspecialchars($this->L_vars[9]).'</p>' : '').'
+										
+										<label for"c-username" class="c-username first">
+											'.htmlspecialchars($this->L_vars[0]).':
+											<input type="text" id="c-username" name="username" value="'.htmlspecialchars($this->u).'" class="c-username" />
+										</label>
+										
+										<label for="c-password" class="c-password">
+											'.htmlspecialchars($this->L_vars[1]).':
+											<input type="password" id="c-password" name="p_field" value="'.htmlspecialchars($this->p).'" class="c-password" />
+										</label>
+										
+										'.($this->interfaceSelector && !$this->loginRefresh ? '
+										<label for="class="c-interfaceselector" class="c-interfaceselector">
+											'.htmlspecialchars($this->L_vars[2]).':
+											'.$this->interfaceSelector.'
+										</label>' : '' ).'
+										
+										<input type="submit" name="commandLI" value="'.htmlspecialchars($this->L_vars[3]).'" class="c-submit" />
+										
+										<p class="c-info">
+											'.htmlspecialchars($this->L_vars[7]).'
+										</p>
+									</fieldset>
+								</div>';
+
+			// Return content:
+		return $content;
+	}
+
+	/**
 	 * Wrapping the login form table in another set of tables etc:
 	 *
 	 * @param	string		HTML content for the login form
@@ -332,46 +333,21 @@
 		$loginboxImage = $this->makeLoginBoxImage();
 
 			// Compile the page content:
-		$content='
+		$content='<div id="wrapper">
+								<div id="loginimage">'.$logo.'</div>
+							
+								<div id="loginwrapper">
+									<div '.($this->commandLI ? ' class="error"' : '').'>
+									'.$loginboxImage.$content.'
+									</div>
+								</div>
+								'.$this->makeLoginNews().'
 
-		<!--
-			Wrapper table for the login form:
-		-->
-		<table cellspacing="0" cellpadding="0" border="0" id="wrapper">
-			<tr>
-				<td class="c-wrappercell" align="center">
+								<div id="copyrightnotice">
+									'.$this->makeCopyrightNotice().'
+								</div>
+							</div>';
 
-					<!--
-						Login form image:
-					-->
-					<div id="loginimage">
-											'.$logo.'
-					</div>
-
-					<!--
-						Login form wrapper:
-					-->
-					<table cellspacing="0" cellpadding="0" border="0" id="loginwrapper">
-						<tr>
-							<td'.($this->commandLI ? ' class="error"' : '').'>'.$loginboxImage.
-								$content.'
-							</td>
-						</tr>
-					</table>
-					
-					'.$this->makeLoginNews().'
-					<!--
-						Copyright notice:
-					-->
-					<div id="copyrightnotice">
-						'.$this->makeCopyrightNotice().'
-					</div>
-
-					
-				</td>
-			</tr>
-		</table>';
-
 			// Return content:
 		return $content;
 	}
Index: stylesheet.css
===================================================================
--- stylesheet.css	(revision 3416)
+++ stylesheet.css	(working copy)
@@ -1358,141 +1358,147 @@
 	border: 0px;
 }
 
-/* - - - - - - - - - - - - - - - - - - - - -
+/* Login Screen
 
-Login Screen
-
 	 * Warning:
 	 * DO NOT prevent the copyright notice from being shown!
 	 * According to the GPL license an interactive application must show such a notice on start-up ('If the program is interactive, make it output a short notice... ' - see GPL.txt)
 	 * Therefore preventing this notice from being properly shown is a violation of the license, regardless of whether you remove it or use the stylesheet to obstruct the display.
 
-	 Color set: #A69E8D / #858585
+*/
 
-- - - - - - - - - - - - - - - - - - - - - */
-
 body#typo3-index-php {
-	background-color: white;
+	background-color: #fff;
 	margin: 0;
-	padding: 0;
 }
 
-body#typo3-index-php table#wrapper {
-	width: 100%;
-	margin-top: 30px;
+body#typo3-index-php #wrapper {
+	height: auto;
+	width: 500px;
+	margin: 10px auto 0 auto;
 }
 
-body#typo3-index-php table#loginwrapper {
-	width: 100%;
-	background-color: #7A9FCF;
-	text-align: left;
+body#typo3-index-php #logintable h2 {
+	display:none;
 }
 
-body#typo3-index-php div#copyrightnotice {
-	width: 70%;
-	text-align: left;
-	margin-top: 10px;
+body#typo3-index-php #logintable fieldset {
+	display: block;
+	margin: 0;
+	padding-left:30px;
+	border: 0;
 }
 
-body#typo3-index-php div#copyrightnotice img {
-	margin-right: 5px;
-	margin-bottom: 5px;
+body#typo3-index-php #logintable fieldset legend {
+	display:none;
 }
 
-body#typo3-index-php div#loginimage {
-	text-align: right;
-	padding-right: 30px;
-	margin-bottom: 5px;
-	height: 43px;
+body#typo3-index-php #logintable fieldset {
+	margin: 20px 0 0 0;
 }
 
-table#logintable {
-	position: absolute;
-	left: 35%;
-	top: 78px;
-	margin: 5px 20px 5px 20px;
+body#typo3-index-php #logintable input,
+body#typo3-index-php #logintable select {
+	position: relative;
+	top: -1.4em;
+	left: 100px;
+	width:150px;
+	display: block;
+	font-weight:normal;
 }
 
-table#logintable tr td {
-	padding: 1px 1px 1px 1px;
+body#typo3-index-php #logintable input.c-submit {
+	clear: both;
+	top: 0;
+	width:60px;
 }
 
-table#logintable H2 {
-	background-color: transparent;
-	font-size: 14px;
-	color: white;
-	text-align: left;
+body#typo3-index-php #logintable label {
+	clear: both;
+	float: left;
+	display: block;
+	width: 100px;
+	margin-top: -1em;
+	padding: 8px 0;	
+	font-size: 10px;
+	font-weight: bold;
 }
 
-table#logintable P {
-	font-size: 12px;
-	color: white;
-	font-weight: bold;
+body#typo3-index-php #logintable label.first {
+	margin-top: 1em;
 }
 
-table#logintable P.c-info {
-	font-size: 10px;
-	font-weight: normal;
+body#typo3-index-php .c-info {
+	padding:20px 0 0 0;
 }
 
-table#logintable P.c-wrong {
-	font-size: 10px;
-	width: 300px;
-	border: #858585 solid 1px;
-	margin: 5px 0px 5px 0px;
-	padding: 5px 15px 5px 15px;
+body#typo3-index-php .c-wrong { 
+	font-size: 10px; 
+	width: 300px; 
+	border: #858585 solid 1px; 
+	margin: 5px 0px; 
+	padding: 5px 15px; 
 }
 
-table#logintable input.c-username,
-table#logintable input.c-password,
-table#logintable select.c-interfaceselector {
-	width: 150px;
+body#typo3-index-php div#copyrightnotice {
+	border-top: 1px solid #f69220;
+	width: 500px;
+	text-align: left;
+	margin-top: 50px;
+	padding-top: 13px;
+	font-weight: normal;
+	color: #838383;
 }
 
-table#logintable input {
-	border: #858585 solid 1px;
-	background-color: white;
+body#typo3-index-php div#copyrightnotice a {
+	color: #838383;
+	font-weight: bold;
 }
 
-/* Fix height if an error message is displayed */
+body#typo3-index-php div#copyrightnotice img {
+	display:none;
+}
 
-body#typo3-index-php table#loginwrapper td.error {
-	padding: 25px 0 25px 0;
+body#typo3-index-php div#loginimage {
+	width: 500px;
+	height: auto;
+	text-align:left;
+	padding: 0;
+	margin: 0;
 }
 
-h2#loginNewsTitle {
-	width: 70%;
-	background-color: #F69220;
-	color: #000;
-	padding: 2px 0 0 4px;
+/***************************************************
+* The old login news (might become obsolete?)
+***************************************************/
+
+H2#loginNewsTitle {
+	background-color: #F69220; 
+	color: #000; 
+	padding:2px 0 0 4px;
 }
 
 dl#loginNews {
-	width: 70%;
-	text-align: left;
-	margin-bottom: 20px;
+	margin-bottom:20px; 
 }
 
 dl#loginNews dt {
-	font-weight: bold;
-	font-size: 14px;
+	font-weight:bold;font-size:14px; 
 }
 
 dl#loginNews dt span {
-	font-weight: normal;
-	font-size: 10px;
-	padding-left: 16px;
-	margin-bottom: 4px;
+	font-weight:normal;
+	font-size:10px;
+	padding-left:16px;
+	margin-bottom:4px;
 }
 
-dl#loginNews dd {
-	border-left: 2px solid #F69220;
-	padding-left: 10px;
-	font-size: 12px;
-	margin-bottom: 12px;
+dl#loginNews dt {
+	border-left:2px solid #F69220;
+	padding-left:10px;
+	font-size:12px;
+	margin-bottom:12px;
 }
 
-
 /* - - - - - - - - - - - - - - - - - - - - -
 
 Wizards
@@ -1755,8 +1761,9 @@
 div.typo3-newRecordLink,
 div.typo3-localizationLink,
 div.typo3-synchronizationLink {
-	margin: 5px 0px 5px 0px;
+	margin: 5px 0px;
 	font-weight: bold;
+	cursor: pointer;
 }
 
 div#typo3-newRecordLink img,