Index: typo3/templates/beuser.html
===================================================================
--- typo3/templates/beuser.html	(revision 3422)
+++ typo3/templates/beuser.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath"></div>
+			<div class="pagepath">###FUNC_MENU###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/config.html
===================================================================
--- typo3/templates/config.html	(revision 3422)
+++ typo3/templates/config.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath"></div>
+			<div class="pagepath">###FUNC_MENU###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
Index: typo3/templates/db_layout.html
===================================================================
--- typo3/templates/db_layout.html	(revision 3422)
+++ typo3/templates/db_layout.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######TOP_FUNCTION_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH######PAGEPATH###</div>
+			<div class="pagepath">###CSH######TOP_FUNCTION_MENU######PAGEPATH###</div>
 			<div class="infooptions">###LANGSELECTOR######PAGEINFO###</div>
 		</div>
 	</div>
@@ -31,4 +31,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###RECORD_LIST######CACHE######SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/db_layout_quickedit.html
===================================================================
--- typo3/templates/db_layout_quickedit.html	(revision 3422)
+++ typo3/templates/db_layout_quickedit.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######TOP_FUNCTION_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH######PAGEPATH###</div>
+			<div class="pagepath">###CSH######TOP_FUNCTION_MENU######PAGEPATH###</div>
 			<div class="infooptions">###LANGSELECTOR######PAGEINFO###</div>
 		</div>
 	</div>
@@ -35,4 +35,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###RECORD_LIST######SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/dbint.html
===================================================================
--- typo3/templates/dbint.html	(revision 3422)
+++ typo3/templates/dbint.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath"></div>
+			<div class="pagepath">###FUNC_MENU###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
Index: typo3/templates/em_index.html
===================================================================
--- typo3/templates/em_index.html	(revision 3422)
+++ typo3/templates/em_index.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath"></div>
+			<div class="pagepath">###FUNC_MENU###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
Index: typo3/templates/file_edit.html
===================================================================
--- typo3/templates/file_edit.html	(revision 3422)
+++ typo3/templates/file_edit.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH###&nbsp;###PATH###</div>
+			<div class="pagepath">###CSH######FUNC_MENU######PATH###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/file_list.html
===================================================================
--- typo3/templates/file_list.html	(revision 3422)
+++ typo3/templates/file_list.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH######TITLE###</div>
+			<div class="pagepath">###CSH######FUNC_MENU######TITLE###</div>
 			<div class="infooptions">###FOLDER_INFO###&nbsp;###PAGE_ICON###</div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###REFRESH######LEVEL_UP######SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/file_newfolder.html
===================================================================
--- typo3/templates/file_newfolder.html	(revision 3422)
+++ typo3/templates/file_newfolder.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###PATH###</div>
+			<div class="pagepath">###FUNC_MENU######PATH###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### --><!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/file_rename.html
===================================================================
--- typo3/templates/file_rename.html	(revision 3422)
+++ typo3/templates/file_rename.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH###&nbsp;###PATH###</div>
+			<div class="pagepath">###CSH######FUNC_MENU######PATH###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### --><!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/file_upload.html
===================================================================
--- typo3/templates/file_upload.html	(revision 3422)
+++ typo3/templates/file_upload.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###PATH###</div>
+			<div class="pagepath">###FUNC_MENU######PATH###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### --><!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/func.html
===================================================================
--- typo3/templates/func.html	(revision 3422)
+++ typo3/templates/func.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH######PAGEPATH###</div>
+			<div class="pagepath">###CSH######FUNC_MENU######PAGEPATH###</div>
 			<div class="infooptions">###PAGEINFO###</div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###RECORD_LIST######SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/info.html
===================================================================
--- typo3/templates/info.html	(revision 3422)
+++ typo3/templates/info.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH######PAGEPATH###</div>
+			<div class="pagepath">###CSH######FUNC_MENU######PAGEPATH###</div>
 			<div class="infooptions">###PAGEINFO###</div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###RECORD_LIST######SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/perm.html
===================================================================
--- typo3/templates/perm.html	(revision 3422)
+++ typo3/templates/perm.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH######PAGEPATH###</div>
+			<div class="pagepath">###CSH######FUNC_MENU######PAGEPATH###</div>
 			<div class="infooptions">###PAGEINFO###</div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###RECORD_LIST######SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/tsconfig_help.html
===================================================================
--- typo3/templates/tsconfig_help.html	(revision 3422)
+++ typo3/templates/tsconfig_help.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath"></div>
+			<div class="pagepath">###FUNC_MENU###</div>
 			<div class="infooptions"></div>
 		</div>
 	</div>
Index: typo3/templates/tstemplate.html
===================================================================
--- typo3/templates/tstemplate.html	(revision 3422)
+++ typo3/templates/tstemplate.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH######PAGEPATH###</div>
+			<div class="pagepath">###CSH######FUNC_MENU######PAGEPATH###</div>
 			<div class="infooptions">###PAGEINFO###</div>
 		</div>
 	</div>
@@ -33,4 +33,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###RECORD_LIST######SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->
Index: typo3/templates/version.html
===================================================================
--- typo3/templates/version.html	(revision 3422)
+++ typo3/templates/version.html	(working copy)
@@ -4,10 +4,10 @@
 	<div id="typo3-docheader">
 		<div id="typo3-docheader-row1">
 			<div class="buttonsleft">###BUTTONLIST_LEFT###</div>
-			<div class="buttonsright">###BUTTONLIST_RIGHT######WS_MENU######FUNC_MENU###</div>
+			<div class="buttonsright">###BUTTONLIST_RIGHT###</div>
 		</div>
 		<div id="typo3-docheader-row2">
-			<div class="pagepath">###CSH######PAGEPATH###</div>
+			<div class="pagepath">###CSH######WS_MENU######FUNC_MENU######PAGEPATH###</div>
 			<div class="infooptions">###PAGEINFO###</div>
 		</div>
 	</div>
@@ -30,4 +30,4 @@
 
 <!-- ###BUTTON_GROUPS_RIGHT### -->
 <!-- ###BUTTON_GROUP1### -->###RECORD_LIST######SHORTCUT###<!-- ###BUTTON_GROUP1### -->
-<!-- ###BUTTON_GROUPS_RIGHT### -->
\ No newline at end of file
+<!-- ###BUTTON_GROUPS_RIGHT### -->